diff --git a/include/flecs.h b/include/flecs.h
index e6bf26a1d..8b6fc9a2b 100644
--- a/include/flecs.h
+++ b/include/flecs.h
@@ -272,6 +272,8 @@ typedef struct EcsPipeline {
 /* Runtime properties of pipeline */
 typedef struct EcsPipelineQuery {
     ecs_query_t *query;
+    int32_t match_count;
+    ecs_vector_t *ops;
 } EcsPipelineQuery;
 
 /** Component used for timer functionality */
@@ -1213,6 +1215,16 @@ void* _ecs_column(
 #define ecs_column(rows, type, column)\
     ((type*)_ecs_column(rows, sizeof(type), column))
 
+/** Same as ecs_column, but for const ([in]) columns */
+FLECS_EXPORT
+const void* _ecs_const_column(
+    const ecs_rows_t *rows,
+    size_t size,
+    int32_t column);
+
+#define ecs_const_column(rows, type, column)\
+    ((const type*)_ecs_const_column(rows, sizeof(type), column))
+
 /** Test if column is shared or not. 
  * The following signature shows an example of owned components and shared
  * components:
@@ -1363,6 +1375,10 @@ void* ecs_table_column(
 #define ECS_COLUMN(rows, type, id, column)\
     type *id = ecs_column(rows, type, column)
 
+/** Get a strongly typed pointer to a column (owned or shared). */
+#define ECS_CONST_COLUMN(rows, type, id, column)\
+    const type *id = ecs_const_column(rows, type, column)
+
 /** Obtain a handle to the component of a column */
 #define ECS_COLUMN_COMPONENT(rows, id, column)\
     ECS_ENTITY_VAR(id) = ecs_column_entity(rows, column);\
diff --git a/include/flecs/util/api_support.h b/include/flecs/util/api_support.h
index 6ece13498..ee15f9e3d 100644
--- a/include/flecs/util/api_support.h
+++ b/include/flecs/util/api_support.h
@@ -199,7 +199,7 @@ typedef enum ecs_sig_from_kind_t {
     EcsFromSelf,            /* Get component from self (default) */
     EcsFromOwned,           /* Get owned component from self */
     EcsFromShared,          /* Get shared component from self */
-    EcsFromContainer,       /* Get component from container */
+    EcsFromParent,       /* Get component from container */
     EcsFromSystem,          /* Get component from system */
     EcsFromEmpty,           /* Get entity handle by id */
     EcsFromEntity,          /* Get component from other entity */
diff --git a/src/api_support.c b/src/api_support.c
index 889e3f6ca..ce5388aa9 100644
--- a/src/api_support.c
+++ b/src/api_support.c
@@ -173,8 +173,8 @@ ecs_entity_t ecs_new_prefab(
 
     ecs_entity_t result = lookup(world, name, type.normalized);
     if (!result) {
-        result = ecs_new_w_type(world, type.normalized);
-        ecs_add(world, result, EcsPrefab);
+        result = ecs_new_w_entity(world, EEcsPrefab);
+        ecs_add_type(world, result, type.normalized);
         ecs_set(world, result, EcsName, {name});
     } else {
         if (!ecs_has(world, result, EcsPrefab)) {
diff --git a/src/builtin.c b/src/builtin.c
index 8504d2225..2be341e96 100644
--- a/src/builtin.c
+++ b/src/builtin.c
@@ -1,26 +1,20 @@
 #include "flecs_private.h"
 
 static
-int compare_entity(
-    ecs_entity_t e1, 
-    void *ptr1, 
-    ecs_entity_t e2, 
-    void *ptr2) 
-{
-    return e1 - e2;
-}
-
-static
-int rank_phase(
+void ctor_init_zero(
     ecs_world_t *world,
-    ecs_entity_t rank_component,
-    ecs_type_t type) 
+    ecs_entity_t component,
+    const ecs_entity_t *entities,
+    void *ptr,
+    size_t size,
+    int32_t count,
+    void *ctx)
 {
-    return ecs_type_get_entity_for_xor(world, type, rank_component);
+    memset(ptr, 0, size * count);
 }
 
 static
-void ctor_init_zero(
+void ecs_colsystem_dtor(
     ecs_world_t *world,
     ecs_entity_t component,
     const ecs_entity_t *entities,
@@ -29,7 +23,28 @@ void ctor_init_zero(
     int32_t count,
     void *ctx)
 {
-    memset(ptr, 0, size * count);
+    EcsColSystem *system_data = ptr;
+
+    int i;
+    for (i = 0; i < count; i ++) {
+        EcsColSystem *cur = &system_data[i];
+        ecs_entity_t e = entities[i];
+
+        /* Invoke Deactivated action for active systems */
+        if (cur->query && ecs_vector_count(cur->query->tables)) {
+            ecs_invoke_status_action(world, e, ptr, EcsSystemDeactivated);
+        }
+
+        /* Invoke Disabled action for enabled systems */
+        if (!ecs_has_entity(world, e, EEcsDisabled) && 
+            !ecs_has_entity(world, e, EEcsDisabledIntern)) 
+        {
+            ecs_invoke_status_action(world, e, ptr, EcsSystemDisabled);
+        }           
+
+        ecs_os_free(cur->on_demand);
+        ecs_vector_free(cur->jobs);
+    }
 }
 
 static
@@ -167,44 +182,6 @@ void EcsOnSetComponentLifecycle(
     }
 }
 
-static 
-void EcsOnAddPipeline(
-    ecs_rows_t *rows)
-{
-    ecs_world_t *world = rows->world;
-    ecs_entity_t *entities = rows->entities;
-
-    int32_t i;
-    for (i = rows->count - 1; i >= 0; i --) {
-        ecs_entity_t pipeline = entities[i];
-        ecs_sig_t sig = { 0 };
-
-#ifndef NDEBUG
-        const EcsType *type_ptr = ecs_get_ptr(world, pipeline, EcsType);
-        ecs_assert(type_ptr != NULL, ECS_INTERNAL_ERROR, NULL);
-
-        char *str = ecs_type_str(world, type_ptr->normalized);
-        ecs_trace_1("pipeline #[green]%s#[normal] created with #[red][%s]",
-            ecs_get_name(world, pipeline), str);
-        free(str);
-#endif
-        ecs_trace_push();
-
-        ecs_sig_add(&sig, EcsFromSelf, EcsOperAnd, EcsIn, EEcsColSystem, 0);
-        ecs_sig_add(&sig, EcsFromSelf, EcsOperAnd, EcsIn, ECS_XOR | pipeline, 0);
-        ecs_sig_add(&sig, EcsFromSelf, EcsOperNot, EcsIn, EEcsInactive, 0);
-        ecs_sig_add(&sig, EcsFromSelf, EcsOperNot, EcsIn, EEcsDisabledIntern, 0);
-
-        ecs_query_t *query = ecs_query_new_w_sig(world, 0, &sig);
-        ecs_query_sort(world, query, 0, compare_entity);
-        ecs_query_sort_types(world, query, pipeline, rank_phase);
-
-        ecs_set(world, pipeline, EcsPipelineQuery, { .query = query });
-
-        ecs_trace_pop();
-    }
-}
-
 static 
 void EcsOnSetSystem(
     ecs_rows_t *rows)
@@ -251,29 +228,6 @@ void EcsEnableSystem(
 void ecs_init_system_builtins(
     ecs_world_t *world)
 {
-    /* -- Pipeline creation infrastructure & create builtin pipeline -- */
-
-    /* Phases of the builtin pipeline are regular entities. Names are set so
-     * they can be resolved by type expressions. */
-    ecs_set(world, EcsPreFrame, EcsName, {"EcsPreFrame"});
-    ecs_set(world, EcsOnLoad, EcsName, {"EcsOnLoad"});
-    ecs_set(world, EcsPostLoad, EcsName, {"EcsPostLoad"});
-    ecs_set(world, EcsPreUpdate, EcsName, {"EcsPreUpdate"});
-    ecs_set(world, EcsOnUpdate, EcsName, {"EcsOnUpdate"});
-    ecs_set(world, EcsOnValidate, EcsName, {"EcsOnValidate"});
-    ecs_set(world, EcsPostUpdate, EcsName, {"EcsPostUpdate"});
-    ecs_set(world, EcsPreStore, EcsName, {"EcsPreStore"});
-    ecs_set(world, EcsOnStore, EcsName, {"EcsOnStore"});
-    ecs_set(world, EcsPostFrame, EcsName, {"EcsPostFrame"});
-
-    /* When the Pipeline tag is added a pipeline will be created */
-    ECS_TRIGGER(world, EcsOnAddPipeline, EcsOnAdd, EcsPipeline, 0);
-
-    /* Create the builtin pipeline */
-    world->builtin_pipeline = ecs_new_pipeline(world, "EcsBuiltinPipeline",
-        "EcsPreFrame, EcsOnLoad, EcsPostLoad, EcsPreUpdate, EcsOnUpdate,"
-        " EcsOnValidate, EcsPostUpdate, EcsPreStore, EcsOnStore, EcsPostFrame");
-
     /* -- System creation / enabling / disabling infrastructure -- */
 
     /* When EcsSystem is set, a new system will be created */
@@ -281,7 +235,8 @@ void ecs_init_system_builtins(
 
     /* Initialize EcsColSystem to zero when created */
     ecs_set(world, ecs_entity(EcsColSystem), EcsComponentLifecycle, {
-        .ctor = ctor_init_zero
+        .ctor = ctor_init_zero,
+        .dtor = ecs_colsystem_dtor
     });
 
     /* Monitors that trigger when a system is enabled or disabled */
@@ -320,6 +275,9 @@ void ecs_init_builtins(
         .move = ecs_parent_move
     });
 
+    /* Initialize pipeline builtins */
+    ecs_init_pipeline_builtins(world);
+
     /* Initialize system builtins */
     ecs_init_system_builtins(world);     
 
diff --git a/src/entity.c b/src/entity.c
index d11ad19df..2b1dc4a88 100644
--- a/src/entity.c
+++ b/src/entity.c
@@ -250,6 +250,10 @@ void run_component_trigger(
     int32_t row,
     int32_t count)
 {
+    if (table->flags & EcsTableIsPrefab) {
+        return;
+    }
+
     ecs_entity_t *entities = ecs_vector_first(data->entities);        
     ecs_assert(entities != NULL, ECS_INTERNAL_ERROR, NULL);
     entities = ECS_OFFSET(entities, sizeof(ecs_entity_t) * row);
@@ -489,10 +493,10 @@ void instantiate(
                 /* Run trigger separately for each entity. We can't call the
                  * trigger on the range because we must "trick" the trigger to 
                  * use data from the base but the instance id. */
+
+                ecs_entity_t *entities = ecs_vector_first(data->entities);
                 int j;
                 for (j = row; j < count; j ++) {
-                    ecs_entity_t *entities = ecs_vector_first(data->entities);
-
                     /* Run trigger on base data with instance id */
                     run_component_trigger_for_entities(world, stage, on_set, 
                         *component, info.table, info.data, info.row, 1, 
@@ -531,7 +535,7 @@ void run_init_actions(
 
     int i, cur;
     for (i = 0; i < components.count; i ++) {
-        /* Retrieve component callbacks & systems for component */
+        /* Retrieve component callbacks & triggers for component */
         ecs_entity_t component = components.array[i];
 
         if (component >= ECS_HI_COMPONENT_ID) {
@@ -546,8 +550,8 @@ void run_init_actions(
         void *ctx = cdata->lifecycle.ctx;
         
         ecs_xtor_t ctor = cdata->lifecycle.ctor;
-        ecs_vector_t *systems = cdata->on_add;
-        if (!ctor && !systems && !has_base) {
+        ecs_vector_t *triggers = cdata->on_add;
+        if (!ctor && !triggers && !has_base) {
             continue;
         }
 
@@ -575,9 +579,9 @@ void run_init_actions(
             override_component(world, component, type, column, row, count);
         }
 
-        if (systems) {
+        if (triggers) {
             run_component_trigger(
-                world, stage, systems, component, table, data, 
+                world, stage, triggers, component, table, data, 
                 row, count);
         }
     }
@@ -590,7 +594,8 @@ void ecs_run_deinit_actions(
     ecs_data_t *data,
     uint32_t row,
     uint32_t count,
-    ecs_entities_t components)
+    ecs_entities_t components,
+    bool run_triggers)
 {
     ecs_assert(data != NULL, ECS_INTERNAL_ERROR, NULL);
 
@@ -609,7 +614,7 @@ void ecs_run_deinit_actions(
 
     int i, cur;
     for (i = 0; i < components.count; i ++) {
-        /* Retrieve component callbacks & systems for component */
+        /* Retrieve component callbacks & triggers for component */
         ecs_entity_t component = components.array[i];
         if (component >= ECS_HI_COMPONENT_ID) {
             continue;
@@ -618,9 +623,9 @@ void ecs_run_deinit_actions(
         ecs_component_data_t *cdata = &cdata_array[component];
         void *ctx = cdata->lifecycle.ctx;
         ecs_xtor_t dtor = cdata->lifecycle.dtor;
-        ecs_vector_t *systems = cdata->on_remove;
+        ecs_vector_t *triggers = cdata->on_remove;
         
-        if (!dtor && !systems) {
+        if (!dtor && !triggers) {
             continue;
         }
 
@@ -639,8 +644,10 @@ void ecs_run_deinit_actions(
         void *array = ecs_vector_first(column->data);
         void *ptr = ECS_OFFSET(array, size * row);
 
-        if (systems) {
-
+        if (triggers && run_triggers) {
+            run_component_trigger(
+                world, stage, triggers, component, table, data, 
+                row, count);
         }
 
         if (dtor) {
@@ -668,6 +675,10 @@ void run_monitors(
         return;
     }
 
+    if (dst_table->flags & EcsTableIsPrefab) {
+        return;
+    }
+
     if (!src_table->monitors) {
         ecs_vector_each(dst_table->monitors, ecs_monitor_t, monitor, {
             ecs_run_monitor(world, stage, monitor, dst_row, count);
@@ -786,7 +797,7 @@ uint32_t move_entity(
 
     if (removed) {
         ecs_run_deinit_actions(
-            world, stage, src_table, src_data, src_row, 1, *removed);
+            world, stage, src_table, src_data, src_row, 1, *removed, true);
     }
 
     /* Only delete from source table if it is in the same stage */
@@ -828,7 +839,7 @@ void delete_entity(
 {
     if (removed) {
         ecs_run_deinit_actions(
-            world, stage, src_table, src_data, src_row, 1, *removed);
+            world, stage, src_table, src_data, src_row, 1, *removed, true);
     }
 
     ecs_table_delete(world, stage, src_table, src_data, src_row);
diff --git a/src/flecs_private.h b/src/flecs_private.h
index 2da3935e3..c9c224655 100644
--- a/src/flecs_private.h
+++ b/src/flecs_private.h
@@ -19,6 +19,9 @@ void ecs_init_timer_builtins(
 void ecs_init_system_builtins(
     ecs_world_t *world);    
 
+void ecs_init_pipeline_builtins(
+    ecs_world_t *world);
+
 ////////////////////////////////////////////////////////////////////////////////
 //// Entity API
 ////////////////////////////////////////////////////////////////////////////////
@@ -78,6 +81,11 @@ ecs_component_data_t *ecs_get_component_data(
     ecs_world_t *world,
     ecs_entity_t component);
 
+void ecs_progress_pipeline(
+    ecs_world_t *world,
+    ecs_entity_t pipeline,
+    float delta_time);
+
 ////////////////////////////////////////////////////////////////////////////////
 //// Stage API
 ////////////////////////////////////////////////////////////////////////////////
@@ -151,7 +159,8 @@ void ecs_run_deinit_actions(
     ecs_data_t *data,
     uint32_t row,
     uint32_t count,
-    ecs_entities_t components);
+    ecs_entities_t components,
+    bool run_triggers);
 
 ////////////////////////////////////////////////////////////////////////////////
 //// Table API
@@ -178,11 +187,6 @@ void ecs_table_unregister_monitor(
     ecs_table_t *table,
     ecs_entity_t system);
 
-/* Deinitialize table. This invokes all matching on_remove systems */
-void ecs_table_deinit_components(
-    ecs_world_t *world,
-    ecs_table_t *table);
-
 /* Free table */
 void ecs_table_free(
     ecs_world_t *world,
diff --git a/src/pipeline.c b/src/pipeline.c
new file mode 100644
index 000000000..d0f9e0e28
--- /dev/null
+++ b/src/pipeline.c
@@ -0,0 +1,241 @@
+#include "flecs_private.h"
+
+static
+int compare_entity(
+    ecs_entity_t e1, 
+    void *ptr1, 
+    ecs_entity_t e2, 
+    void *ptr2) 
+{
+    return e1 - e2;
+}
+
+static
+int rank_phase(
+    ecs_world_t *world,
+    ecs_entity_t rank_component,
+    ecs_type_t type) 
+{
+    return ecs_type_get_entity_for_xor(world, type, rank_component);
+}
+
+typedef enum ComponentWriteState {
+    NotWritten = 0,
+    WriteToMain,
+    WriteToStage
+} ComponentWriteState;
+
+static
+bool check_column_component(
+    ecs_sig_column_t *column,
+    int32_t component,
+    int8_t *write_state)    
+{
+    int8_t state = write_state[component];
+
+    if (column->from_kind == EcsFromSelf && column->oper_kind != EcsOperNot) {
+        switch(column->inout_kind) {
+        case EcsInOut:
+        case EcsIn:
+            if (state == WriteToStage) {
+                return true;
+            }
+        case EcsOut:
+            if (column->inout_kind != EcsIn) {
+                write_state[component] = WriteToMain;
+            }
+        };
+    } else if (column->from_kind == EcsFromEmpty || column->oper_kind == EcsOperNot) {
+        switch(column->inout_kind) {
+        case EcsInOut:
+        case EcsOut:
+            write_state[component] = WriteToStage;
+        default:
+            break;
+        };
+    }
+
+    return false;
+}
+
+static
+bool check_column(
+    ecs_sig_column_t *column,
+    int8_t *write_state)
+{
+    if (column->oper_kind != EcsOperOr) {
+        return check_column_component(column, column->is.component, write_state);
+    }  
+
+    return false;
+}
+
+static
+ecs_vector_t* build_pipeline(
+    ecs_world_t *world,
+    ecs_query_t *query)
+{
+    int8_t *write_state = ecs_os_calloc(ECS_HI_COMPONENT_ID, sizeof(int8_t));
+    ecs_vector_t *ops = NULL;
+    ecs_pipeline_op_t *op = NULL;
+
+    /* Iterate systems in pipeline, add ops for running / merging */
+    ecs_query_iter_t it = ecs_query_iter(query, 0, 0);
+    while (ecs_query_next(&it)) {
+        ecs_rows_t *rows = &it.rows;
+        EcsColSystem *sys = ecs_column(rows, EcsColSystem, 1);
+
+        int i;
+        for (i = 0; i < rows->count; i ++) {
+            ecs_query_t *q = sys[i].query;
+            if (!q) {
+                continue;
+            }
+
+            bool needs_merge = false;
+            ecs_vector_each(q->sig.columns, ecs_sig_column_t, column, {
+                needs_merge |= check_column(column, write_state);
+            });
+
+            if (needs_merge) {
+                /* After merge all components will be merged, so reset state */
+                memset(write_state, 0, ECS_HI_COMPONENT_ID * sizeof(int8_t));
+                op = NULL;
+            }
+
+            if (!op) {
+                op = ecs_vector_add(&ops, ecs_pipeline_op_t);
+                op->count = 0;
+            }
+
+            op->count ++;
+        }
+    }
+
+    ecs_os_free(write_state);
+
+    return ops;
+}
+
+static 
+void EcsOnAddPipeline(
+    ecs_rows_t *rows)
+{
+    ecs_world_t *world = rows->world;
+    ecs_entity_t *entities = rows->entities;
+
+    int32_t i;
+    for (i = rows->count - 1; i >= 0; i --) {
+        ecs_entity_t pipeline = entities[i];
+        ecs_sig_t sig = { 0 };
+
+#ifndef NDEBUG
+        const EcsType *type_ptr = ecs_get_ptr(world, pipeline, EcsType);
+        ecs_assert(type_ptr != NULL, ECS_INTERNAL_ERROR, NULL);
+
+        char *str = ecs_type_str(world, type_ptr->normalized);
+        ecs_trace_1("pipeline #[green]%s#[normal] created with #[red][%s]",
+            ecs_get_name(world, pipeline), str);
+        free(str);
+#endif
+        ecs_trace_push();
+
+        /* Build signature for pipeline quey that matches EcsColSystems, has the
+         * pipeline as a XOR column, and ignores systems with EcsInactive and
+         * EcsDisabledIntern. Note that EcsDisabled is automatically ignored by
+         * the regular query matching */
+        ecs_sig_add(&sig, EcsFromSelf, EcsOperAnd, EcsIn, EEcsColSystem, 0);
+        ecs_sig_add(&sig, EcsFromSelf, EcsOperAnd, EcsIn, ECS_XOR | pipeline, 0);
+        ecs_sig_add(&sig, EcsFromSelf, EcsOperNot, EcsIn, EEcsInactive, 0);
+        ecs_sig_add(&sig, EcsFromSelf, EcsOperNot, EcsIn, EEcsDisabledIntern, 0);
+
+        /* Create the query. Sort the query by system id and phase */
+        ecs_query_t *query = ecs_query_new_w_sig(world, 0, &sig);
+        ecs_query_sort(world, query, 0, compare_entity);
+        ecs_query_sort_types(world, query, pipeline, rank_phase);
+
+        ecs_set(world, pipeline, EcsPipelineQuery, { 
+            .query = query,
+            .match_count = query->match_count,
+            .ops = build_pipeline(world, query)
+        });
+
+        ecs_trace_pop();
+    }
+}
+
+void ecs_init_pipeline_builtins(
+    ecs_world_t *world)
+{
+    /* -- Pipeline creation infrastructure & create builtin pipeline -- */
+
+    /* Phases of the builtin pipeline are regular entities. Names are set so
+     * they can be resolved by type expressions. */
+    ecs_set(world, EcsPreFrame, EcsName, {"EcsPreFrame"});
+    ecs_set(world, EcsOnLoad, EcsName, {"EcsOnLoad"});
+    ecs_set(world, EcsPostLoad, EcsName, {"EcsPostLoad"});
+    ecs_set(world, EcsPreUpdate, EcsName, {"EcsPreUpdate"});
+    ecs_set(world, EcsOnUpdate, EcsName, {"EcsOnUpdate"});
+    ecs_set(world, EcsOnValidate, EcsName, {"EcsOnValidate"});
+    ecs_set(world, EcsPostUpdate, EcsName, {"EcsPostUpdate"});
+    ecs_set(world, EcsPreStore, EcsName, {"EcsPreStore"});
+    ecs_set(world, EcsOnStore, EcsName, {"EcsOnStore"});
+    ecs_set(world, EcsPostFrame, EcsName, {"EcsPostFrame"});
+
+    /* When the Pipeline tag is added a pipeline will be created */
+    ECS_TRIGGER(world, EcsOnAddPipeline, EcsOnAdd, EcsPipeline, 0);
+
+    /* Create the builtin pipeline */
+    world->builtin_pipeline = ecs_new_pipeline(world, "EcsBuiltinPipeline",
+        "EcsPreFrame, EcsOnLoad, EcsPostLoad, EcsPreUpdate, EcsOnUpdate,"
+        " EcsOnValidate, EcsPostUpdate, EcsPreStore, EcsOnStore, EcsPostFrame");
+}
+
+void ecs_progress_pipeline(
+    ecs_world_t *world,
+    ecs_entity_t pipeline,
+    float delta_time)
+{
+    EcsPipelineQuery *query = ecs_get_mut(
+        world, pipeline, EcsPipelineQuery, NULL);
+
+    ecs_assert(query != NULL, ECS_INTERNAL_ERROR, NULL);
+    ecs_assert(query->query != NULL, ECS_INTERNAL_ERROR, NULL);
+
+    if (query->match_count != query->query->match_count) {
+        ecs_vector_free(query->ops);
+        query->ops = build_pipeline(world, query->query);
+    }
+
+    ecs_time_t start = {0};
+    ecs_time_measure(&start);
+
+    int32_t count_since_merge = 0;
+    ecs_vector_t *ops = query->ops;
+    ecs_pipeline_op_t *op = ecs_vector_first(ops);
+    
+    ecs_query_iter_t it = ecs_query_iter(query->query, 0, 0);
+    while (ecs_query_next(&it)) {
+        ecs_rows_t *rows = &it.rows;
+        ECS_COLUMN(rows, EcsColSystem, sys, 1);
+
+        int32_t i;
+        for(i = 0; i < rows->count; i ++) {
+            ecs_entity_t e = rows->entities[i];
+            ecs_run_intern(world, world, e, &sys[i], delta_time, 0, 0, 
+                NULL, NULL);
+
+            count_since_merge ++;
+
+            if (count_since_merge == op->count) {
+                ecs_staging_end(world, false);
+                ecs_merge(world);
+                ecs_staging_begin(world);
+                count_since_merge = 0;
+                op ++;
+            }
+        }
+    }
+
+    world->system_time_total += ecs_time_measure(&start);
+}
diff --git a/src/query.c b/src/query.c
index 8c1cc1470..bb9906621 100644
--- a/src/query.c
+++ b/src/query.c
@@ -139,6 +139,8 @@ void order_ranked_tables(
                 world, table->table, query->system, table_i);
         })
     }
+
+    query->match_count ++; 
 }
 
 static
@@ -254,6 +256,7 @@ void add_table(
 
         if (op == EcsOperNot) {
             from = EcsFromEmpty;
+            entity = column->source;
         }        
 
         /* Column that retrieves data from self or a fixed entity */
@@ -280,7 +283,7 @@ void add_table(
             table_data->columns[c] = 0;
 
         /* Column that retrieves data from a dynamic entity */
-        } else if (from == EcsFromContainer || from == EcsCascade) {
+        } else if (from == EcsFromParent || from == EcsCascade) {
             if (op == EcsOperAnd ||
                 op == EcsOperOptional)
             {
@@ -308,7 +311,7 @@ void add_table(
         }
 
         /* This column does not retrieve data from a static entity (either
-         * EcsFromSystem or EcsFromContainer) and is not just a handle */
+         * EcsFromSystem or EcsFromParent) and is not just a handle */
         if (!entity && from != EcsFromEmpty) {
             if (component) {
                 /* Retrieve offset for component */
@@ -393,9 +396,9 @@ void add_table(
                 ref->component = component;
 
                 if (component_data->size) {
-                    if (e) {
-                        ref->cached_ptr = (ecs_cached_ptr_t){0};
+                    ref->cached_ptr = (ecs_cached_ptr_t){0};
 
+                    if (e) {
                         ecs_get_cached_ptr_w_entity(
                             world, &ref->cached_ptr, e, component);
                         ecs_set_watch(world, &world->stage, e);                     
@@ -439,7 +442,7 @@ bool match_column(
         return !ecs_type_has_owned_entity(world, type, component, true) &&
             ecs_type_has_owned_entity(world, type, component, false);
 
-    } else if (from_kind == EcsFromContainer) {
+    } else if (from_kind == EcsFromParent) {
         failure_info->reason = EcsMatchFromContainer;
         return ecs_components_contains_component(
             world, type, component, ECS_CHILDOF, NULL);
@@ -529,7 +532,7 @@ bool match_table(
                     failure_info->reason = EcsMatchOrFromSelf;
                     return false;
                 }
-            } else if (from_kind == EcsFromContainer) {
+            } else if (from_kind == EcsFromParent) {
                 if (!components_contains(
                     world, table_type, type, NULL, false))
                 {
@@ -862,7 +865,9 @@ void build_sorted_tables(
 
     if (start != i) {
         build_sorted_table_range(world, query, start, i);
-    }    
+    }
+
+    query->match_count ++; 
 }
 
 static
@@ -1006,13 +1011,14 @@ void process_signature(
         if (from == EcsFromSelf || 
             from == EcsFromOwned ||
             from == EcsFromShared ||
-            from == EcsFromContainer) 
+            from == EcsFromParent) 
         {
             query->needs_matching = true;
         }
 
         if (from == EcsCascade) {
             query->cascade_by = i;
+            query->rank_on_component = column->is.component;
         }
 
         if (from == EcsFromEntity) {
@@ -1174,6 +1180,7 @@ ecs_query_t* ecs_query_new_w_sig(
     result->tables = ecs_vector_new(ecs_matched_table_t, 0);
     result->inactive_tables = ecs_vector_new(ecs_matched_table_t, 0);
     result->system = system;
+    result->match_count = 0;
 
     process_signature(world, result);
 
@@ -1194,7 +1201,6 @@ ecs_query_t* ecs_query_new_w_sig(
     }
 
     if (result->cascade_by) {
-        result->rank_on_component = result->cascade_by;
         result->rank_table = rank_by_depth;
     }
 
@@ -1218,21 +1224,23 @@ ecs_query_t* ecs_query_new(
 void ecs_query_free(
     ecs_query_t *query)
 {
-    int32_t t;
-    ecs_matched_table_t *tables = ecs_vector_first(query->inactive_tables);
-    for (t = 0; t < ecs_vector_count(query->inactive_tables); t ++) {
-        ecs_os_free(tables[t].columns);
-        ecs_os_free(tables[t].components);
-    }
-
-    tables = ecs_vector_first(query->tables);
-    for (t = 0; t < ecs_vector_count(query->tables); t ++) {
-        ecs_os_free(tables[t].columns);
-        ecs_os_free(tables[t].components);
-    }
+    ecs_vector_each(query->inactive_tables, ecs_matched_table_t, table, {
+        ecs_os_free(table->columns);
+        ecs_os_free(table->components);
+        ecs_vector_free(table->references);
+        ecs_os_free(table->monitor);
+    });
+
+    ecs_vector_each(query->tables, ecs_matched_table_t, table, {
+        ecs_os_free(table->columns);
+        ecs_os_free(table->components);
+        ecs_vector_free(table->references);
+        ecs_os_free(table->monitor);
+    });
 
     ecs_vector_free(query->tables);
     ecs_vector_free(query->inactive_tables);
+    ecs_vector_free(query->table_ranges);
     ecs_sig_deinit(&query->sig);
 }
 
diff --git a/src/rows.c b/src/rows.c
index 2605bd76b..801b52965 100644
--- a/src/rows.c
+++ b/src/rows.c
@@ -103,6 +103,15 @@ void* _ecs_column(
     const ecs_rows_t *rows,
     size_t size,
     int32_t column)
+{
+    // ecs_assert(!ecs_is_readonly(rows, column), ECS_COLUMN_ACCESS_VIOLATION, NULL);
+    return get_column(rows, size, column, 0);
+}
+
+const void* _ecs_const_column(
+    const ecs_rows_t *rows,
+    size_t size,
+    int32_t column)
 {
     return get_column(rows, size, column, 0);
 }
@@ -137,10 +146,14 @@ bool ecs_is_readonly(
         return true;
     }
 
-    ecs_sig_column_t *column_data = ecs_vector_get(
-        rows->query->sig.columns, ecs_sig_column_t, column - 1);
-
-    return column_data->inout_kind == EcsIn;
+    ecs_query_t *query = rows->query;
+    if (query) {
+        ecs_sig_column_t *column_data = ecs_vector_get(
+            rows->query->sig.columns, ecs_sig_column_t, column - 1);
+        return column_data->inout_kind == EcsIn;
+    } else {
+        return true;
+    }
 }
 
 ecs_entity_t ecs_column_source(
diff --git a/src/signature.c b/src/signature.c
index 548d23dc9..e7935d6a6 100644
--- a/src/signature.c
+++ b/src/signature.c
@@ -47,7 +47,7 @@ char* parse_complex_elem(
         if (bptr == dot) {
             *from_kind = EcsFromEmpty;
         } else if (!strncmp(bptr, "PARENT", dot - bptr)) {
-            *from_kind = EcsFromContainer;
+            *from_kind = EcsFromParent;
         } else if (!strncmp(bptr, "SYSTEM", dot - bptr)) {
             *from_kind = EcsFromSystem;
         } else if (!strncmp(bptr, "SELF", dot - bptr)) {
diff --git a/src/stage.c b/src/stage.c
index 29d82e38e..ac11a7894 100644
--- a/src/stage.c
+++ b/src/stage.c
@@ -221,46 +221,6 @@ void clean_tables(
     }
 }
 
-/* -- Private functions -- */
-
-void ecs_stage_init(
-    ecs_world_t *world,
-    ecs_stage_t *stage)
-{
-    bool is_main_stage = stage == &world->stage;
-    bool is_temp_stage = stage == &world->temp_stage;
-
-    memset(stage, 0, sizeof(ecs_stage_t));
-
-    /* Initialize entity index */
-    ecs_eis_new(stage);
-
-    if (is_main_stage) {
-        stage->id = 0;
-    } else if (is_temp_stage) {
-        stage->id = 1;
-    }
-
-    /* Initialize root table */
-    stage->tables = ecs_sparse_new(ecs_table_t, 64);
-
-    /* Initialize one root table per stage */
-    ecs_init_root_table(world, stage);
-
-    stage->range_check_enabled = true;
-}
-
-void ecs_stage_deinit(
-    ecs_world_t *world,
-    ecs_stage_t *stage)
-{
-    clean_tables(world, stage);
-    ecs_sparse_free(stage->tables);
-    ecs_table_free(world, &stage->root);
-    ecs_vector_free(stage->dirty_tables);
-    ecs_eis_free(stage);
-}
-
 static
 void merge_tables(
     ecs_world_t *world,
@@ -331,6 +291,8 @@ void merge_tables(
     }
 }
 
+/* -- Private functions -- */
+
 void ecs_stage_merge(
     ecs_world_t *world,
     ecs_stage_t *stage)
@@ -354,3 +316,41 @@ void ecs_stage_merge(
     ecs_sparse_clear(stage->tables);
     ecs_eis_clear(stage);
 }
+
+void ecs_stage_init(
+    ecs_world_t *world,
+    ecs_stage_t *stage)
+{
+    bool is_main_stage = stage == &world->stage;
+    bool is_temp_stage = stage == &world->temp_stage;
+
+    memset(stage, 0, sizeof(ecs_stage_t));
+
+    /* Initialize entity index */
+    ecs_eis_new(stage);
+
+    if (is_main_stage) {
+        stage->id = 0;
+    } else if (is_temp_stage) {
+        stage->id = 1;
+    }
+
+    /* Initialize root table */
+    stage->tables = ecs_sparse_new(ecs_table_t, 64);
+
+    /* Initialize one root table per stage */
+    ecs_init_root_table(world, stage);
+
+    stage->range_check_enabled = true;
+}
+
+void ecs_stage_deinit(
+    ecs_world_t *world,
+    ecs_stage_t *stage)
+{
+    clean_tables(world, stage);
+    ecs_sparse_free(stage->tables);
+    ecs_table_free(world, &stage->root);
+    ecs_vector_free(stage->dirty_tables);
+    ecs_eis_free(stage);
+}
\ No newline at end of file
diff --git a/src/system.c b/src/system.c
index 1359ef5ad..dd1087c2f 100644
--- a/src/system.c
+++ b/src/system.c
@@ -232,7 +232,7 @@ void ecs_init_system(
     activate_in_columns(
         world, system_data->query, 
         world->on_enable_components, 
-        true);   
+        true);
 
     /* Check if all non-table column constraints are met. If not, disable
      * system (system will be enabled once constraints are met) */
diff --git a/src/table.c b/src/table.c
index abf1ed4ca..f4e03f218 100644
--- a/src/table.c
+++ b/src/table.c
@@ -101,8 +101,9 @@ void run_on_remove_handlers(
             .count = ecs_vector_count(table->type)
         };
 
+        /* Run deinit actions (dtors) for components. Don't run triggers */
         ecs_run_deinit_actions(
-            world, &world->stage, table, data, 0, count, components);
+            world, &world->stage, table, data, 0, count, components, false);
     }
 }
 
@@ -393,15 +394,6 @@ void ecs_table_clear(
     ecs_table_clear_silent(world, table);
 }
 
-/* This operation is called when the world is freed. Because of the sequence in
- * which things are cleaned up, this cannot be combined with ecs_table_free. */
-void ecs_table_deinit_components(
-    ecs_world_t *world,
-    ecs_table_t *table)
-{
-    run_on_remove_handlers(world, table);
-}
-
 /* Free table resources. Do not invoke handlers and do not activate/deactivate
  * table with systems. This function is used when the world is freed. */
 void ecs_table_free(
@@ -409,11 +401,14 @@ void ecs_table_free(
     ecs_table_t *table)
 {
     (void)world;
+    run_on_remove_handlers(world, table);
     deinit_all_data(table);
     ecs_os_free(table->lo_edges);
     ecs_map_free(table->hi_edges);
     ecs_vector_free(table->queries);
     ecs_vector_free((ecs_vector_t*)table->type);
+    ecs_os_free(table->dirty_state);
+    ecs_vector_free(table->monitors);
 }
 
 /* Replace columns. Activate / deactivate table with systems if necessary. */
diff --git a/src/table_graph.c b/src/table_graph.c
index cae3691a8..6b9cf1bac 100644
--- a/src/table_graph.c
+++ b/src/table_graph.c
@@ -94,6 +94,7 @@ void init_edges(
 
             /* Register child table with parent */
             ecs_entity_t parent = e & ECS_ENTITY_MASK;
+
             EcsParent *ptr = ecs_get_mut(world, parent, EcsParent, NULL);
             ecs_table_t **el = ecs_vector_add(&ptr->child_tables, ecs_table_t*);
             *el = table;
@@ -623,20 +624,6 @@ int32_t count_occurrences(
     return count;
 }
 
-#ifndef NDEBUG
-static
-char *entities_to_str(
-    ecs_world_t *world,
-    ecs_entities_t *entities)
-{
-    ecs_vector_t *vec = ecs_vector_new(ecs_entity_t, entities->count);
-    ecs_entity_t *array = ecs_vector_first(vec);
-    memcpy(array, entities->array, sizeof(ecs_entity_t) * entities->count);
-    ecs_vector_set_count(&vec, ecs_entity_t, entities->count);
-    return ecs_type_str(world, vec);
-}
-#endif
-
 static
 void verify_constraints(
     ecs_world_t *world,
@@ -655,16 +642,13 @@ void verify_constraints(
 
         switch(mask) {
         case ECS_OR:
-            ecs_assert(matches >= 1, ECS_TYPE_CONSTRAINT_VIOLATION, 
-                entities_to_str(world, entities));
+            ecs_assert(matches >= 1, ECS_TYPE_CONSTRAINT_VIOLATION, NULL);
             break;
         case ECS_XOR:
-            ecs_assert(matches == 1, ECS_TYPE_CONSTRAINT_VIOLATION, 
-                entities_to_str(world, entities));
+            ecs_assert(matches == 1, ECS_TYPE_CONSTRAINT_VIOLATION, NULL);
             break;
         case ECS_NOT:
-            ecs_assert(matches == 0, ECS_TYPE_CONSTRAINT_VIOLATION, 
-                entities_to_str(world, entities));    
+            ecs_assert(matches == 0, ECS_TYPE_CONSTRAINT_VIOLATION, NULL);    
             break;
         }
     }
diff --git a/src/timer.c b/src/timer.c
index e7691de86..73abdcd67 100644
--- a/src/timer.c
+++ b/src/timer.c
@@ -33,8 +33,7 @@ void EcsProgressTimers(ecs_rows_t *rows) {
                 t = 0;
             }
 
-            timer[i].time = t; /* Initialize with remainder */
-            
+            timer[i].time = t; /* Initialize with remainder */            
             tick_source[i].tick = true;
             tick_source[i].time_elapsed = time_elapsed;
 
@@ -89,19 +88,19 @@ void ecs_init_timer_builtins(
 {
     /* Add EcsTickSource to timers and rate filters */
     world->add_tick_source =
-    ecs_new_system(world, "EcsAddTickSource", 0, 
+    ecs_new_system(world, "EcsAddTickSource", EcsPreFrame, 
         "[in] EcsTimer || EcsRateFilter, [out] !EcsTickSource", 
         EcsAddTickSource);
 
     /* Timer handling */
     world->progress_timers = 
-    ecs_new_system(world, "EcsProgressTimers", 0, 
+    ecs_new_system(world, "EcsProgressTimers", EcsPreFrame, 
         "EcsTimer, EcsTickSource", 
         EcsProgressTimers);
     
     /* Rate filter handling */
     world->progress_rate_filters = 
-    ecs_new_system(world, "EcsProgressRateFilters", 0, 
+    ecs_new_system(world, "EcsProgressRateFilters", EcsPreFrame, 
         "[in] EcsRateFilter, [out] EcsTickSource", 
         EcsProgressRateFilters);    
 }
diff --git a/src/types.h b/src/types.h
index f04b7fe20..bbecf76eb 100644
--- a/src/types.h
+++ b/src/types.h
@@ -72,6 +72,16 @@ typedef int (*ecs_parse_action_t)(
     const char *source,
     void *ctx);
 
+typedef enum EcsPipelineOp {
+    EcsPipelineRun,
+    EcsPipelineMerge
+} EcsPipelineOp;
+
+typedef struct ecs_pipeline_op_t {
+    EcsPipelineOp kind;
+    int32_t count;
+} ecs_pipeline_op_t;
+
 /** A component array in a table */
 struct ecs_column_t {
     ecs_vector_t *data;              /* Column data */
@@ -177,6 +187,7 @@ struct ecs_query_t {
     bool is_monitor;            /* Should query register as monitor? */
     int32_t cascade_by;         /* Identify CASCADE column */
     bool needs_matching;        /* Does sig need to be matched with tables */
+    int32_t match_count;        /* How often has table administration changed */
 };
 
 /** Keep track of how many [in] columns are active for [out] columns of OnDemand
diff --git a/src/world.c b/src/world.c
index c7f323965..6cce5fbb6 100644
--- a/src/world.c
+++ b/src/world.c
@@ -211,19 +211,6 @@ ecs_stage_t *ecs_get_stage(
     return NULL;
 }
 
-static
-void deinit_tables(
-    ecs_world_t *world)
-{
-    ecs_sparse_t *tables = world->stage.tables;
-    int32_t i, count = ecs_sparse_count(tables);
-
-    for (i = 0; i < count; i ++) {
-        ecs_table_t *table = ecs_sparse_get(tables, ecs_table_t, i);
-        ecs_table_deinit_components(world, table);
-    }
-}
-
 /* -- Public functions -- */
 
 ecs_world_t *ecs_init(void) {
@@ -480,16 +467,20 @@ int ecs_fini(
     assert(!world->in_progress);
     assert(!world->is_merging);
 
+    /* Cleanup threading administration */
     if (world->worker_threads) {
         ecs_set_threads(world, 0);
     }
 
     if (world->locking_enabled) {
         ecs_os_mutex_free(world->mutex);
-    }    
+    }
 
-    deinit_tables(world);
+    /* Cleanup stages */
+    ecs_stage_deinit(world, &world->stage);
+    ecs_stage_deinit(world, &world->temp_stage);
 
+    /* Cleanup component lifecycle callbacks & systems */
     int32_t i, count = ecs_vector_count(world->component_data);
     ecs_component_data_t *cdata = ecs_vector_first(world->component_data);
 
@@ -500,25 +491,25 @@ int ecs_fini(
     }
     ecs_vector_free(world->component_data);
 
+    /* Cleanup queries */
     count = ecs_sparse_count(world->queries);
     for (i = 0; i < count; i ++) {
         ecs_query_t *q = ecs_sparse_get(world->queries, ecs_query_t, i);
         ecs_query_free(q);
     }
-
     ecs_sparse_free(world->queries);
-    ecs_map_free(world->type_handles);
-
-    ecs_stage_deinit(world, &world->stage);
-    ecs_stage_deinit(world, &world->temp_stage);
 
+    /* Cleanup misc data structures */
     on_demand_in_map_deinit(world->on_activate_components);
     on_demand_in_map_deinit(world->on_enable_components);
-
+    ecs_map_free(world->type_handles);
     ecs_vector_free(world->fini_tasks);
 
+    /* In case the application tries to use the memory of the freed world, this
+     * will trigger an assert */
     world->magic = 0;
 
+    /* The end of the world */
     ecs_os_free(world);
 
 #ifdef __BAKE__
@@ -748,7 +739,7 @@ float ecs_frame_begin(
     bool is_staged = ecs_staging_begin(world);
     ecs_assert(!is_staged, ECS_INTERNAL_ERROR, NULL);
     
-    return delta_time;
+    return user_delta_time;
 }
 
 void ecs_frame_end(
@@ -767,36 +758,6 @@ void ecs_frame_end(
     stop_measure_frame(world, delta_time);   
 }
 
-void ecs_progress_pipeline(
-    ecs_world_t *world,
-    ecs_entity_t pipeline,
-    float delta_time)
-{
-    const EcsPipelineQuery *query = ecs_get_ptr(
-        world, pipeline, EcsPipelineQuery);
-
-    ecs_assert(query != NULL, ECS_INTERNAL_ERROR, NULL);
-    ecs_assert(query->query != NULL, ECS_INTERNAL_ERROR, NULL);
-
-    ecs_time_t start = {0};
-    ecs_time_measure(&start);
-    
-    ecs_query_iter_t it = ecs_query_iter(query->query, 0, 0);
-    while (ecs_query_next(&it)) {
-        ecs_rows_t *rows = &it.rows;
-        ECS_COLUMN(rows, EcsColSystem, sys, 1);
-
-        int32_t i;
-        for(i = 0; i < rows->count; i ++) {
-            ecs_entity_t e = rows->entities[i];
-            ecs_run_intern(world, world, e, &sys[i], delta_time, 0, 0, 
-                NULL, NULL);
-        }
-    }
-
-    world->system_time_total += ecs_time_measure(&start);
-}
-
 bool ecs_progress(
     ecs_world_t *world,
     float user_delta_time)
diff --git a/test/api/project.json b/test/api/project.json
index 372959329..7a70a3325 100644
--- a/test/api/project.json
+++ b/test/api/project.json
@@ -321,7 +321,6 @@
                 "override_after_add_in_on_add",
                 "add_again_in_progress",
                 "add_in_progress_before_system_def",
-                "disabled_system",
                 "2_systems_w_table_creation",
                 "2_systems_w_table_creation_in_progress",
                 "sys_context",
@@ -336,7 +335,6 @@
                 "delete_match_1_of_1",
                 "delete_match_1_of_2",
                 "delete_no_match_1",
-                "disabled_system",
                 "remove_watched",
                 "delete_watched"
             ]
@@ -352,8 +350,7 @@
                 "on_set_after_override",
                 "on_set_after_override_w_new",
                 "on_set_after_override_w_new_w_count",
-                "on_set_after_override_1_of_2_overridden",
-                "disabled_system"
+                "on_set_after_override_1_of_2_overridden"
             ]
         }, {
             "id": "SystemOnFrame",
@@ -582,9 +579,6 @@
             "testcases": [
                 "2_column_1_from_system",
                 "3_column_2_from_system",
-                "2_column_1_from_system_on_add",
-                "2_column_1_from_system_on_remove",
-                "2_column_1_from_system_on_set",
                 "auto_add_tag"
             ]
         }, {
diff --git a/test/api/src/Prefab.c b/test/api/src/Prefab.c
index 9d2546c80..44c12b5ce 100644
--- a/test/api/src/Prefab.c
+++ b/test/api/src/Prefab.c
@@ -1515,7 +1515,7 @@ void Prefab_ignore_on_add() {
 
     ECS_COMPONENT(world, Position);
 
-    ECS_SYSTEM(world, PrefabReactiveTest, EcsOnAdd, Position);
+    ECS_TRIGGER(world, PrefabReactiveTest, EcsOnAdd, Position, NULL);
 
     ECS_PREFAB(world, Prefab, Position);
 
@@ -1529,7 +1529,7 @@ void Prefab_ignore_on_remove() {
 
     ECS_COMPONENT(world, Position);
 
-    ECS_SYSTEM(world, PrefabReactiveTest, EcsOnRemove, Position);
+    ECS_TRIGGER(world, PrefabReactiveTest, EcsOnRemove, Position, NULL);
 
     ECS_PREFAB(world, Prefab, Position);
 
@@ -1547,7 +1547,7 @@ void Prefab_ignore_on_set() {
 
     ECS_COMPONENT(world, Position);
 
-    ECS_SYSTEM(world, PrefabReactiveTest, EcsOnSet, Position);
+    ECS_TRIGGER(world, PrefabReactiveTest, EcsOnSet, Position, NULL);
 
     ECS_PREFAB(world, Prefab, Position);
 
@@ -1565,7 +1565,7 @@ void Prefab_on_set_on_instance() {
 
     ECS_COMPONENT(world, Position);
 
-    ECS_SYSTEM(world, PrefabReactiveTest, EcsOnSet, Position);
+    ECS_TRIGGER(world, PrefabReactiveTest, EcsOnSet, Position, NULL);
 
     ECS_PREFAB(world, Prefab, Position);
 
@@ -2027,7 +2027,7 @@ void Prefab_nested_prefab_in_progress_w_count_set_after_override() {
             ecs_set(world, ChildPrefab, Velocity, {3, 4});
 
     ECS_SYSTEM(world, NewPrefab_w_count, EcsOnUpdate, .Prefab);
-    ECS_SYSTEM(world, OnSetVelocity, EcsOnSet, Velocity);
+    ECS_TRIGGER(world, OnSetVelocity, EcsOnSet, Velocity, NULL);
 
     ecs_entity_t result = 0;
     ecs_set_context(world, &result);
@@ -2493,7 +2493,7 @@ void Prefab_clone_after_inherit_in_on_add() {
     ecs_world_t *world = ecs_init();
 
     ECS_COMPONENT(world, Position);
-    ECS_SYSTEM(world, CloneInOnAdd, EcsOnAdd, Position);
+    ECS_TRIGGER(world, CloneInOnAdd, EcsOnAdd, Position, NULL);
 
     ecs_entity_t e = ecs_new(world, Position);
     test_assert(e != 0);
@@ -2569,8 +2569,8 @@ void Prefab_create_multiple_nested_w_on_add() {
         ECS_TYPE(world, Child, CHILDOF | Prefab, INSTANCEOF | ChildPrefab, ecs_entity_t);
             ecs_set(world, ChildPrefab, Velocity, {3, 4});
 
-    ECS_SYSTEM(world, OnAddEntity, EcsOnAdd, ecs_entity_t);
-    ECS_SYSTEM(world, OnSetVelocity, EcsOnSet, Velocity);
+    ECS_TRIGGER(world, OnAddEntity, EcsOnAdd, ecs_entity_t, NULL);
+    ECS_TRIGGER(world, OnSetVelocity, EcsOnSet, Velocity, NULL);
 
     /* Create two entities with separate calls */ 
     ecs_entity_t e1 = ecs_new_w_entity(world, ECS_INSTANCEOF | Prefab);
@@ -2642,8 +2642,8 @@ void Prefab_create_multiple_nested_w_on_add_in_progress() {
             ecs_set(world, ChildPrefab, Velocity, {3, 4});
 
     ECS_SYSTEM(world, CreateInstances, EcsOnUpdate, .Prefab);
-    ECS_SYSTEM(world, OnAddEntity, EcsOnAdd, ecs_entity_t);
-    ECS_SYSTEM(world, OnSetVelocity, EcsOnSet, Velocity);
+    ECS_TRIGGER(world, OnAddEntity, EcsOnAdd, ecs_entity_t, NULL);
+    ECS_TRIGGER(world, OnSetVelocity, EcsOnSet, Velocity, NULL);
 
     ecs_progress(world, 1);
 
diff --git a/test/api/src/SingleThreadStaging.c b/test/api/src/SingleThreadStaging.c
index 5be54845a..6a5270471 100644
--- a/test/api/src/SingleThreadStaging.c
+++ b/test/api/src/SingleThreadStaging.c
@@ -735,17 +735,19 @@ void Remove_from_current(ecs_rows_t *rows) {
     IterData *ctx = ecs_get_context(rows->world);
 
     int i;
-    for (i = 0; i < rows->count; i ++) {
+    for (i = rows->count - 1; i >= 0; i --) {
+        ecs_entity_t e = rows->entities[i];
+
         if (ctx->component) {
-            ecs_remove_entity(rows->world, rows->entities[i], ctx->component);
-            test_assert( !ecs_has_entity(rows->world,  rows->entities[i], ctx->component));
-            test_assert( ecs_get_ptr_w_entity(rows->world, rows->entities[i], ctx->component) == NULL);
+            ecs_remove_entity(rows->world, e, ctx->component);
+            test_assert( !ecs_has_entity(rows->world,  e, ctx->component));
+            test_assert( ecs_get_ptr_w_entity(rows->world, e, ctx->component) == NULL);
         }
 
         if (ctx->component_2) {
-            ecs_remove_entity(rows->world, rows->entities[i], ctx->component_2);
-            test_assert( !ecs_has_entity(rows->world,  rows->entities[i], ctx->component_2));
-            test_assert( ecs_get_ptr_w_entity(rows->world, rows->entities[i], ctx->component_2) == NULL);
+            ecs_remove_entity(rows->world, e, ctx->component_2);
+            test_assert( !ecs_has_entity(rows->world, e, ctx->component_2));
+            test_assert( ecs_get_ptr_w_entity(rows->world, e, ctx->component_2) == NULL);
         }
 
         ctx->entity_count ++;
diff --git a/test/api/src/SystemOnAdd.c b/test/api/src/SystemOnAdd.c
index 13abf655a..966ff6a92 100644
--- a/test/api/src/SystemOnAdd.c
+++ b/test/api/src/SystemOnAdd.c
@@ -1,13 +1,5 @@
 #include <api.h>
 
-static
-void install_test_abort() {
-    ecs_os_set_api_defaults();
-    ecs_os_api_t os_api = ecs_os_api;
-    os_api.abort = test_abort;
-    ecs_os_set_api(&os_api);
-}
-
 void Init(ecs_rows_t *rows) {
     ECS_COLUMN(rows, Position, p, 1);
     
@@ -505,7 +497,7 @@ void SystemOnAdd_set_after_add_in_on_add() {
 
     test_int(ctx.count, 1);
     test_int(ctx.invoked, 1);
-    test_int(ctx.system, Init);
+    test_int(ctx.system, AddVelocity);
     test_int(ctx.column_count, 2);
 
     test_int(ctx.e[0], e);
@@ -687,7 +679,3 @@ void SystemOnAdd_get_sys_context_from_param() {
 
     ecs_fini(world);
 }
-
-void SystemOnAdd_disabled_system() {
-    // Implement testcase
-}
diff --git a/test/api/src/SystemOnRemove.c b/test/api/src/SystemOnRemove.c
index 139c4e09b..522a84e22 100644
--- a/test/api/src/SystemOnRemove.c
+++ b/test/api/src/SystemOnRemove.c
@@ -179,36 +179,6 @@ void SystemOnRemove_delete_no_match_1() {
     ecs_fini(world);
 }
 
-static int is_invoked;
-
-static
-void IsInvoked(ecs_rows_t *rows) {
-    is_invoked ++;
-}
-
-void SystemOnRemove_disabled_system() {
-    ecs_world_t *world = ecs_init();
-
-    ECS_COMPONENT(world, Position);
-    ECS_TRIGGER(world, IsInvoked, EcsOnRemove, Position, NULL);
-
-    ecs_enable(world, IsInvoked, false);
-
-    Probe ctx = {0};
-    ecs_set_context(world, &ctx);
-
-    ecs_entity_t e = ecs_new(world, Position);
-    test_assert(e != 0);
-    test_assert( ecs_has(world, e, Position));
-
-    ecs_remove(world, e, Position);
-    test_assert( !ecs_has(world, e, Position));
-
-    test_int(is_invoked, 0);
-
-    ecs_fini(world);
-}
-
 static Position old_position = {0};
 
 static
diff --git a/test/api/src/SystemOnSet.c b/test/api/src/SystemOnSet.c
index 5b251b30e..42130d9c1 100644
--- a/test/api/src/SystemOnSet.c
+++ b/test/api/src/SystemOnSet.c
@@ -398,7 +398,7 @@ void SystemOnSet_on_set_after_override_w_new() {
 
     const Position *p = ecs_get_ptr(world, e, Position);
     test_assert(p != NULL);
-    test_int(p->x, 2);
+    test_int(p->x, 1);
     test_int(p->y, 3);
 }
 
@@ -477,30 +477,3 @@ void SystemOnSet_on_set_after_override_1_of_2_overridden() {
     test_int(p->x, 2);
     test_int(p->y, 3);
 }
-
-static int is_invoked;
-
-static
-void IsInvoked(ecs_rows_t *rows) {
-    is_invoked ++;
-}
-
-void SystemOnSet_disabled_system() {
-    ecs_world_t *world = ecs_init();
-
-    ECS_COMPONENT(world, Position);
-    ECS_TRIGGER(world, IsInvoked, EcsOnSet, Position, NULL);
-
-    ecs_enable(world, IsInvoked, false);
-
-    Probe ctx = {0};
-    ecs_set_context(world, &ctx);
-
-    ecs_entity_t e = ecs_set(world, 0, Position, {10, 20});
-    test_assert(e != 0);
-    test_assert( ecs_has(world, e, Position));
-
-    test_int(is_invoked, 0);
-
-    ecs_fini(world);
-}
diff --git a/test/api/src/System_w_FromSystem.c b/test/api/src/System_w_FromSystem.c
index f01814cdf..e0135e31d 100644
--- a/test/api/src/System_w_FromSystem.c
+++ b/test/api/src/System_w_FromSystem.c
@@ -2,6 +2,7 @@
 
 void InitVelocity(ecs_rows_t *rows) {
     ECS_COLUMN(rows, Velocity, v, 1);
+
     int i;
     for (i = 0; i < rows->count; i ++) {
         v[i].x = 10;
@@ -53,7 +54,7 @@ void System_w_FromSystem_2_column_1_from_system() {
     ECS_COMPONENT(world, Position);
     ECS_COMPONENT(world, Velocity);
 
-    ECS_SYSTEM(world, InitVelocity, EcsOnAdd, Velocity);
+    ECS_TRIGGER(world, InitVelocity, EcsOnAdd, Velocity, NULL);
     ECS_SYSTEM(world, Iter, EcsOnUpdate, Position, SYSTEM.Velocity);
 
     test_assert( ecs_has(world, Iter, Velocity));
@@ -101,8 +102,8 @@ void System_w_FromSystem_3_column_2_from_system() {
     ECS_COMPONENT(world, Velocity);
     ECS_COMPONENT(world, Mass);
 
-    ECS_SYSTEM(world, InitVelocity, EcsOnAdd, Velocity);
-    ECS_SYSTEM(world, InitMass, EcsOnAdd, Mass);
+    ECS_TRIGGER(world, InitVelocity, EcsOnAdd, Velocity, NULL);
+    ECS_TRIGGER(world, InitMass, EcsOnAdd, Mass, NULL);
     ECS_SYSTEM(world, Iter, EcsOnUpdate, Position, SYSTEM.Velocity, SYSTEM.Mass);
 
     test_assert( ecs_has(world, Iter, Velocity));
@@ -153,7 +154,7 @@ void System_w_FromSystem_3_column_2_from_system() {
 void Iter_reactive(ecs_rows_t *rows) {
     ECS_COLUMN(rows, Position, p, 1);
 
-    Velocity *v = NULL;
+    Velocity *v = rows->param;
     Mass *m = NULL;
 
     if (rows->column_count >= 2) {
@@ -161,11 +162,6 @@ void Iter_reactive(ecs_rows_t *rows) {
         test_assert(ecs_is_shared(rows, 2));
     }
 
-    if (rows->column_count >= 3) {
-        m = ecs_column(rows, Mass, 3);
-        test_assert(!m || ecs_is_shared(rows, 3));
-    }
-
     probe_system(rows);
 
     int i;
@@ -180,129 +176,8 @@ void Iter_reactive(ecs_rows_t *rows) {
     }
 }
 
-void System_w_FromSystem_2_column_1_from_system_on_add() {
-    ecs_world_t *world = ecs_init();
-
-    ECS_COMPONENT(world, Position);
-    ECS_COMPONENT(world, Velocity);
-
-    ECS_SYSTEM(world, InitVelocity, EcsOnAdd, Velocity);
-    ECS_SYSTEM(world, Iter_reactive, EcsOnAdd, Position, SYSTEM.Velocity);
-
-    test_assert( ecs_has(world, Iter_reactive, Velocity));
-    const Velocity *v = ecs_get_ptr(world, Iter_reactive, Velocity);
-    test_assert(v != NULL);
-    test_int(v->x, 10);
-    test_int(v->y, 20);
-
-    Probe ctx = {0};
-    ecs_set_context(world, &ctx);
-
-    ecs_entity_t e = ecs_new(world, Position);
-    
-    test_int(ctx.count, 1);
-    test_int(ctx.invoked, 1);
-    test_int(ctx.system, Iter_reactive);
-    test_int(ctx.column_count, 2);
-    test_null(ctx.param);
-
-    test_int(ctx.e[0], e);
-    test_int(ctx.c[0][0], ecs_entity(Position));
-    test_int(ctx.s[0][0], 0);
-    test_int(ctx.c[0][1], ecs_entity(Velocity));
-    test_int(ctx.s[0][1], Iter_reactive);
-
-    const Position *p = ecs_get_ptr(world, e, Position);
-    test_assert(p != NULL);
-    test_int(p->x, 10);
-    test_int(p->y, 20);
-
-    ecs_fini(world);
-}
-
-void System_w_FromSystem_2_column_1_from_system_on_remove() {
-    ecs_world_t *world = ecs_init();
-
-    ECS_COMPONENT(world, Position);
-    ECS_COMPONENT(world, Velocity);
-
-    ECS_SYSTEM(world, InitVelocity, EcsOnAdd, Velocity);
-    ECS_SYSTEM(world, Iter_reactive, EcsOnRemove, Position, SYSTEM.Velocity);
-
-    test_assert( ecs_has(world, Iter_reactive, Velocity));
-    const Velocity *v = ecs_get_ptr(world, Iter_reactive, Velocity);
-    test_assert(v != NULL);
-    test_int(v->x, 10);
-    test_int(v->y, 20);
-
-    Probe ctx = {0};
-    ecs_set_context(world, &ctx);
-
-    ecs_entity_t e = ecs_new(world, Position);
-    test_int(ctx.count, 0);
-
-    ecs_remove(world, e, Position);
-    
-    test_int(ctx.count, 1);
-    test_int(ctx.invoked, 1);
-    test_int(ctx.system, Iter_reactive);
-    test_int(ctx.column_count, 2);
-    test_null(ctx.param);
-
-    test_int(ctx.e[0], e);
-    test_int(ctx.c[0][0], ecs_entity(Position));
-    test_int(ctx.s[0][0], 0);
-    test_int(ctx.c[0][1], ecs_entity(Velocity));
-    test_int(ctx.s[0][1], Iter_reactive);
-
-    ecs_fini(world);
-}
-
-void System_w_FromSystem_2_column_1_from_system_on_set() {
-    ecs_world_t *world = ecs_init();
-
-    ECS_COMPONENT(world, Position);
-    ECS_COMPONENT(world, Velocity);
-
-    ECS_SYSTEM(world, InitVelocity, EcsOnAdd, Velocity);
-    ECS_SYSTEM(world, Iter_reactive, EcsOnSet, Position, SYSTEM.Velocity);
-
-    test_assert( ecs_has(world, Iter_reactive, Velocity));
-    const Velocity *v = ecs_get_ptr(world, Iter_reactive, Velocity);
-    test_assert(v != NULL);
-    test_int(v->x, 10);
-    test_int(v->y, 20);
-
-    Probe ctx = {0};
-    ecs_set_context(world, &ctx);
-
-    ecs_entity_t e = ecs_set(world, 0, Position, {10, 20});
-    
-    test_int(ctx.count, 1);
-    test_int(ctx.invoked, 1);
-    test_int(ctx.system, Iter_reactive);
-    test_int(ctx.column_count, 2);
-    test_null(ctx.param);
-
-    test_int(ctx.e[0], e);
-    test_int(ctx.c[0][0], ecs_entity(Position));
-    test_int(ctx.s[0][0], 0);
-    test_int(ctx.c[0][1], ecs_entity(Velocity));
-    test_int(ctx.s[0][1], Iter_reactive);
-
-    const Position *p = ecs_get_ptr(world, e, Position);
-    test_assert(p != NULL);
-    test_int(p->x, 10);
-    test_int(p->y, 20);
-
-    ecs_fini(world);
-}
-
 void Dummy_1(ecs_rows_t *rows) { }
 void Dummy_2(ecs_rows_t *rows) { }
-void Dummy_3(ecs_rows_t *rows) { }
-void Dummy_4(ecs_rows_t *rows) { }
-void Dummy_5(ecs_rows_t *rows) { }
 
 void System_w_FromSystem_auto_add_tag() {
     ecs_world_t *world = ecs_init();
@@ -310,16 +185,10 @@ void System_w_FromSystem_auto_add_tag() {
     ECS_COMPONENT(world, Position);
 
     ECS_SYSTEM(world, Dummy_1, EcsOnUpdate, Position, SYSTEM.EcsHidden);
-    ECS_SYSTEM(world, Dummy_2, EcsOnAdd, Position, SYSTEM.EcsHidden);
-    ECS_SYSTEM(world, Dummy_3, EcsOnRemove, Position, SYSTEM.EcsHidden);
-    ECS_SYSTEM(world, Dummy_4, EcsOnSet, Position, SYSTEM.EcsHidden);
-    ECS_SYSTEM(world, Dummy_5, 0, Position, SYSTEM.EcsHidden);
+    ECS_SYSTEM(world, Dummy_2, 0, Position, SYSTEM.EcsHidden);
 
     test_assert( ecs_has(world, Dummy_1, EcsHidden));
     test_assert( ecs_has(world, Dummy_2, EcsHidden));
-    test_assert( ecs_has(world, Dummy_3, EcsHidden));
-    test_assert( ecs_has(world, Dummy_4, EcsHidden));
-    test_assert( ecs_has(world, Dummy_5, EcsHidden));
 
     ecs_fini(world);
 }
diff --git a/test/api/src/main.c b/test/api/src/main.c
index 1fcad0ce8..dbd658ff9 100644
--- a/test/api/src/main.c
+++ b/test/api/src/main.c
@@ -286,7 +286,6 @@ void SystemOnAdd_add_again_2(void);
 void SystemOnAdd_override_after_add_in_on_add(void);
 void SystemOnAdd_add_again_in_progress(void);
 void SystemOnAdd_add_in_progress_before_system_def(void);
-void SystemOnAdd_disabled_system(void);
 void SystemOnAdd_2_systems_w_table_creation(void);
 void SystemOnAdd_2_systems_w_table_creation_in_progress(void);
 void SystemOnAdd_sys_context(void);
@@ -299,7 +298,6 @@ void SystemOnRemove_remove_no_match_1(void);
 void SystemOnRemove_delete_match_1_of_1(void);
 void SystemOnRemove_delete_match_1_of_2(void);
 void SystemOnRemove_delete_no_match_1(void);
-void SystemOnRemove_disabled_system(void);
 void SystemOnRemove_remove_watched(void);
 void SystemOnRemove_delete_watched(void);
 
@@ -314,7 +312,6 @@ void SystemOnSet_on_set_after_override(void);
 void SystemOnSet_on_set_after_override_w_new(void);
 void SystemOnSet_on_set_after_override_w_new_w_count(void);
 void SystemOnSet_on_set_after_override_1_of_2_overridden(void);
-void SystemOnSet_disabled_system(void);
 
 // Testsuite 'SystemOnFrame'
 void SystemOnFrame_1_type_1_component(void);
@@ -523,9 +520,6 @@ void System_w_FromId_column_type(void);
 // Testsuite 'System_w_FromSystem'
 void System_w_FromSystem_2_column_1_from_system(void);
 void System_w_FromSystem_3_column_2_from_system(void);
-void System_w_FromSystem_2_column_1_from_system_on_add(void);
-void System_w_FromSystem_2_column_1_from_system_on_remove(void);
-void System_w_FromSystem_2_column_1_from_system_on_set(void);
 void System_w_FromSystem_auto_add_tag(void);
 
 // Testsuite 'System_w_FromEntity'
@@ -1857,7 +1851,7 @@ static bake_test_suite suites[] = {
     },
     {
         .id = "SystemOnAdd",
-        .testcase_count = 22,
+        .testcase_count = 21,
         .testcases = (bake_test_case[]){
             {
                 .id = "new_match_1_of_1",
@@ -1927,10 +1921,6 @@ static bake_test_suite suites[] = {
                 .id = "add_in_progress_before_system_def",
                 .function = SystemOnAdd_add_in_progress_before_system_def
             },
-            {
-                .id = "disabled_system",
-                .function = SystemOnAdd_disabled_system
-            },
             {
                 .id = "2_systems_w_table_creation",
                 .function = SystemOnAdd_2_systems_w_table_creation
@@ -1951,7 +1941,7 @@ static bake_test_suite suites[] = {
     },
     {
         .id = "SystemOnRemove",
-        .testcase_count = 9,
+        .testcase_count = 8,
         .testcases = (bake_test_case[]){
             {
                 .id = "remove_match_1_of_1",
@@ -1977,10 +1967,6 @@ static bake_test_suite suites[] = {
                 .id = "delete_no_match_1",
                 .function = SystemOnRemove_delete_no_match_1
             },
-            {
-                .id = "disabled_system",
-                .function = SystemOnRemove_disabled_system
-            },
             {
                 .id = "remove_watched",
                 .function = SystemOnRemove_remove_watched
@@ -1993,7 +1979,7 @@ static bake_test_suite suites[] = {
     },
     {
         .id = "SystemOnSet",
-        .testcase_count = 11,
+        .testcase_count = 10,
         .testcases = (bake_test_case[]){
             {
                 .id = "set",
@@ -2034,10 +2020,6 @@ static bake_test_suite suites[] = {
             {
                 .id = "on_set_after_override_1_of_2_overridden",
                 .function = SystemOnSet_on_set_after_override_1_of_2_overridden
-            },
-            {
-                .id = "disabled_system",
-                .function = SystemOnSet_disabled_system
             }
         }
     },
@@ -2841,7 +2823,7 @@ static bake_test_suite suites[] = {
     },
     {
         .id = "System_w_FromSystem",
-        .testcase_count = 6,
+        .testcase_count = 3,
         .testcases = (bake_test_case[]){
             {
                 .id = "2_column_1_from_system",
@@ -2851,18 +2833,6 @@ static bake_test_suite suites[] = {
                 .id = "3_column_2_from_system",
                 .function = System_w_FromSystem_3_column_2_from_system
             },
-            {
-                .id = "2_column_1_from_system_on_add",
-                .function = System_w_FromSystem_2_column_1_from_system_on_add
-            },
-            {
-                .id = "2_column_1_from_system_on_remove",
-                .function = System_w_FromSystem_2_column_1_from_system_on_remove
-            },
-            {
-                .id = "2_column_1_from_system_on_set",
-                .function = System_w_FromSystem_2_column_1_from_system_on_set
-            },
             {
                 .id = "auto_add_tag",
                 .function = System_w_FromSystem_auto_add_tag
